package ch.metas.soa.prototyping.jboss.marshalling.ejb;

import javax.ejb.EJB;
import javax.ejb.Stateless;

import ch.metas.soa.prototyping.jboss.marshalling.ifc.DemoService;
import ch.metas.soa.prototyping.jboss.marshalling.models.Book;
import ch.metas.soa.prototyping.jboss.marshalling.models.BookShelf;

@Stateless
@EJB(name = "java:global/ejb1/DemoService", beanInterface = DemoService.class)
public class DemoService1 implements DemoService {

	@EJB
	DAO m_dao;

	/* (non-Javadoc)
	 * @see ch.metas.soa.prototyping.jboss.marshalling.ejb.DemoService#getBookShelf()
	 */
	@Override
	public BookShelf getBookShelf() {
		BookShelf shelf = m_dao.findFirstBookShelfById(1);
		return shelf;
	}

	@Override
	public Book getFirstBook() {
		Book book = m_dao.findFirstBookById(1);
		return book;
	}

	/* (non-Javadoc)
	 * @see ch.metas.soa.prototyping.jboss.marshalling.ejb.DemoService#initialize()
	 */
	@Override
	public void initialize() {
		BookShelf bookShelf = getBookShelf();
		if (bookShelf != null) {
			return;
		}

		bookShelf = new BookShelf();
		bookShelf.setId(1);
		bookShelf = m_dao.save(bookShelf);

		// create books
		Book book1 = new Book();
		book1.setId(1);
		book1.setName("Book1");
		book1.setBookShelf(bookShelf);
		book1 = m_dao.save(book1);

		Book book2 = new Book();
		book2.setId(2);
		book2.setName("Book2");
		book2.setBookShelf(bookShelf);
		book2 = m_dao.save(book2);
	}
}
